﻿REM
REM forutsetter at parameter er omgitt med anførselstegn -> "
REM 

echo off
REM
REM logging
REM 
set logFile=%temp%\webdocopenlog.txt
echo logFile=%logFile%
echo %0 %1 > %logFile%

set url=%1
set url=%url:~1,-1%
set protocol=%url:~0,6%
set newUrl=%url:webdav=http%
echo url = %url%
echo protocol = %protocol%
if %protocol%==webdav goto protok
echo ingen stottet protokoll
goto slutt
:protok
set extension=%~x1
echo extension=%extension%

REM 
REM Forsøker automatisk kobling mellom extension og redigeringsapplikasjon
REM
set regKey1=HKCR\%extension%
echo regKey1 = %regKey1% 
echo regKey1 = %regKey1% >> %logFile%
REG QUERY %regKey1%  >> %logFile%
if %errorlevel%==1 goto manual
echo regKey1.query = ok

REM
REM test om extension\shell\open\command finnes
REM
set regKey2=%regKey1%\shell\open\command
echo regKey2 = %regKey2%
echo regKey2 = %regKey2% >> %logFile%
REG QUERY %regKey2%  >> %logFile%
if %errorlevel%==1 goto regKey3
echo regKey2.query = ok
set cmdLine=
for /f "tokens=1,2,3,4*" %%a in ('REG QUERY %regKey2%') do (
	echo token=%%a %%b %%c %%d %%e
	IF "%%a"=="<UTEN" set cmdLine=%%d %%e
	IF "%%a"=="(Default)" set cmdLine=%%c %%d %%e
)

goto autorun

:regKey3
REM
REM test om extension\shell\open\command finnes
REM
set regKey3=%regKey1% /ve
echo regKey3 = %regKey3%
echo regKey3 = %regKey3% >> %logFile%
REG QUERY %regKey3% >> %logFile%
if %errorlevel%==1 goto manual
echo regKey3.query = ok

REM 
REM Hent nøkkel
REM
echo for.regKey3.query

for /f "tokens=1,2,3,4*" %%a in ('REG QUERY %regKey3%') do (
	echo token=%%a %%b %%c %%d
	IF "%%a"=="<UTEN" set regKey4=%%d
	IF "%%a"=="(Default)" set regKey4=%%c %%d
)
echo regKey.for.testresult=%test%
REM for /f "tokens=4" %%i in ('REG QUERY %regKey3%') do set regKey4=%%i 
REM if "%regKey4%"=="" for /f "tokens=3" %%i in ('REG QUERY %regKey3%') do set regKey4=%%i 
call :TRIMSUB %regKey4%
set regKey4=%tempvar%
echo regKey4=%regKey4%
echo regKey4="%regKey4%" >> %logFile%

REM 
REM Hent command open
REM
set regKey5=HKCR\%regKey4%\shell\open\command
echo regKey5 = %regKey5%
echo regKey5 = %regKey5% >> %logFile%
REG QUERY %regKey5%  >> %logFile%

REM 
REM Hent command line
REM
set cmdLine=
for /f "tokens=1,2,3,4*" %%a in ('REG QUERY %regKey5%') do (
	echo token=%%a %%b %%c %%d %%e
	IF "%%a"=="<UTEN" set cmdLine=%%d %%e
	IF "%%a"=="(Default)" set cmdLine=%%c %%d %%e
)
echo cmdLine=%cmdLine%
echo cmdLine=%cmdLine% >> %logFile%
if  [!cmdLine!]==[] goto checkProgIDs
if  [!cmdLine!]==[ ] goto checkProgIDs
goto autorun

:checkProgIDs
REM
REM test om extension\OpenWithProgIDs finnes
REM
set regKeyPID=%regKey1%\OpenWithProgIDs
echo Get Registry key PID = %regKeyPID%
echo Get Registry key PID = %regKeyPID% >> %logFile%
REG QUERY %regKeyPID%  >> %logFile%
if %errorlevel%==1 goto manual
echo RegKeyPID %regKeyPID%
for /f "skip=2 tokens=1*" %%A in ('REG QUERY %regKeyPID%') do (
	set regKeyPID2=HKCR\%%A\shell\open\command
	echo Inne i For A=%%A B=%%B
	echo regKeyPID2=%regKeyPID2%
)
echo Get Registry key PID2 = %regKeyPID2%
echo Get Registry key PID2 = %regKeyPID2% >> %logFile%
REG QUERY %regKeyPID2%  >> %logFile%

REM 
REM Hent command line OpenWithProgIDs
REM
set cmdLine=
for /f "skip=2 tokens=3*" %%A in ('REG QUERY %regKeyPID2%') do (
	set cmdLine=%%A %%B
	if %%A==REG_SZ set cmdLine=%%B
	echo Inne i For A=%%A B=%%B
)
echo cmdLine=%cmdLine%
echo cmdLine=%cmdLine% >> %logFile%

REM if "%cmdLine%"=="" goto manual
REM if "%cmdLine%"==" " goto manual

echo Goto autorun
goto autorun

if %errorlevel%==1 goto manual
goto autorun

:emptyCmdLine

for /f "skip=2 tokens=2*" %%A in ('REG QUERY %regKey5%') do (
	set cmdLine=%%A %%B
	if %%A==REG_SZ set cmdLine=%%B
	echo Inne i For A=%%A B=%%B
)
echo cmdLine=%cmdLine%
echo cmdLine=%cmdLine% >> %logFile%


:autorun
echo autorun....
REM
REM bytte ut "%1" med newurl
set actualCmdLine=
set actualCmdLine=%cmdLine:"%1"=% %newUrl%
echo Virkelig kommandolinje = %actualCmdLine% 
echo Virkelig kommandolinje = %actualCmdLine%  >> %logFile%

%actualCmdLine% 

goto slutt

:TRIMSUB
  set tempvar=%*
  GOTO :EOF

:manual
echo manuell kobling
echo Noe galt?
echo Se i logg = %logFile%
set /p
REM 
REM Manuell kobling mellom extension og redigeringsapplikasjon
REM

REM
REM Sett inn kontroller for hver dokumenttype under
REM
if "%extension%"==".odt" goto sofficeok
if "%extension%"==".ods" goto sofficeok
if "%extension%"==".odg" goto sofficeok
if "%extension%"==".doc" goto wordok
if "%extension%"==".docx" goto wordok
if "%extension%"==".xls" goto excelok
if "%extension%"==".xlsx" goto excelok
echo ingen gyldig extension funnet, forsøker webdocopen
webdocopen.exe "%1"
goto slutt
:sofficeok
rem
rem soffice / libreoffice
rem
"c:\programfiler\libreoffice 5\program\soffice" "%newUrl%"
goto slutt
:wordok
rem
rem Microsoft Word
rem
"c:\program files\Microsoft\Word\winword" "%newUrl%"
goto slutt
:excelok
rem
rem Microsoft Excel
rem
"c:\program files\Microsoft\excel\excel" "%newUrl%"
goto slutt
echo "webdav"

:slutt
echo done
